-- Series.lua
-- Script for Fendt 1000 Vario
--
-- Author Steph33
-- 23.11.2016
-- Version 1.0 @23.11.2016
	--> indoorsound change when door/Krisha/backWindow/leftWindow/RightWindow are open

Series = {};

function Series.prerequisitesPresent(specializations)
    return true;
end;

function Series:load(savegame)
	self.soundAdj = {};
	local i=0;
    while true do
        local key = string.format("vehicle.indoorsoundAdjustment.animation(%d)", i);
        if not hasXMLProperty(self.xmlFile, key) then
            break;
        end;
        local animName = getXMLString(self.xmlFile, key.."#name");
        local lowpassGain = Utils.getNoNil(getXMLFloat(self.xmlFile, key.."#lowpassGain"), 0.5);
        local volumeFactor = Utils.getNoNil(getXMLFloat(self.xmlFile, key.."#volumeFactor"), 0.5);
		self.soundAdj[i] = {};
		self.soundAdj[i].animName = animName;
		self.soundAdj[i].volumeFactor = volumeFactor;
		self.soundAdj[i].lowpassGain = lowpassGain;
        i = i +1;
    end;
	
	if self.isClient then
	    --MKleftDoor--
		self.sampleOpenMkDoorL = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.openDoorSound", "sound/door_open.ogg", self.baseDirectory, self.components[1].node);
		self.sampleCloseMkDoorL = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.closeDoorSound", "sound/door_close.wav", self.baseDirectory, self.components[1].node);
		--MkrightDoor--
		self.sampleOpenMkDoorR = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.openDoorSound", "sound/door_open.ogg", self.baseDirectory, self.components[1].node);
		self.sampleCloseMkDoorR = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.closeDoorSound", "sound/door_close.wav", self.baseDirectory, self.components[1].node);
		--DKleftDoor--
		self.sampleOpenDkDoorL = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.openDoorSound", "sound/door_open.ogg", self.baseDirectory, self.components[1].node);
		self.sampleCloseDkDoorL = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.closeDoorSound", "sound/door_close.wav", self.baseDirectory, self.components[1].node);
		--DKrightDoor--
		self.sampleOpenDkDoorR = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.openDoorSound", "sound/door_open.ogg", self.baseDirectory, self.components[1].node);
		self.sampleCloseDkDoorR = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.closeDoorSound", "sound/door_close.wav", self.baseDirectory, self.components[1].node);
		--DkbackWindow--
		self.sampleOpenDkbackWindow = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.openbackWindowSound", "sound/window_open.ogg", self.baseDirectory, self.components[1].node);
		self.sampleCloseDkbackWindow = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.closebackWindowSound", "sound/window_close.wav", self.baseDirectory, self.components[1].node);
		--MkbackWindow--
		self.sampleOpenMkbackWindow = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.openbackWindowSound", "sound/window_open.ogg", self.baseDirectory, self.components[1].node);
		self.sampleCloseMkbackWindow = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.closebackWindowSound", "sound/window_close.wav", self.baseDirectory, self.components[1].node);
		--leftWindow--
		self.sampleOpenleftWindow = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.openLeftWindowSound", "sound/window_open.ogg", self.baseDirectory, self.components[1].node);
		self.sampleCloseleftWindow = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.closeLeftWindowSound", "sound/window_close.wav", self.baseDirectory, self.components[1].node);
		--RightWindow--
		self.sampleOpenrightWindow = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.openRightWindowSound", "sound/window_open.ogg", self.baseDirectory, self.components[1].node);
		self.sampleCloserightWindow = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.closeRightWindowSound", "sound/window_close.wav", self.baseDirectory, self.components[1].node);
	end;
end;
--function Series:postLoad(savegame)
--	for k,v in pairs(self.sampleMotor) do print(k,v) end
--end;
function Series:delete()
	if self.sampleOpenMkDoorL ~= nil then
		SoundUtil.deleteSample(self.sampleOpenMkDoorL);
	end;
	if self.sampleOpenMkDoorR ~= nil then
		SoundUtil.deleteSample(self.sampleOpenMkDoorR);
	end;
	if self.sampleOpenDkDoorL ~= nil then
		SoundUtil.deleteSample(self.sampleOpenDkDoorL);
	end;
	if self.sampleOpenDkDoorR ~= nil then
		SoundUtil.deleteSample(self.sampleOpenDkDoorR);
	end;
	if self.sampleOpenMkbackWindow ~= nil then
		SoundUtil.deleteSample(self.sampleOpenMkbackWindow);
	end;
	if self.sampleOpenDkbackWindow ~= nil then
		SoundUtil.deleteSample(self.sampleOpenDkbackWindow);
	end;
	if self.sampleOpenLeftWindow ~= nil then
		SoundUtil.deleteSample(self.sampleOpenLeftWindow);
	end;
	if self.sampleOpenRightWindow ~= nil then
		SoundUtil.deleteSample(self.sampleOpenRightWindow);
	end;
	if self.sampleCloseMkDoorL ~= nil then
		SoundUtil.deleteSample(self.sampleCloseMkDoorL);
	end;
	if self.sampleCloseMkDoorR ~= nil then
		SoundUtil.deleteSample(self.sampleCloseMkDoorR);
	end;
	if self.sampleCloseDkDoorL ~= nil then
		SoundUtil.deleteSample(self.sampleCloseDkDoorL);
	end;
	if self.sampleCloseDkDoorR ~= nil then
		SoundUtil.deleteSample(self.sampleCloseDkDoorR);
	end;
	if self.sampleCloseMkbackWindow ~= nil then
		SoundUtil.deleteSample(self.sampleCloseMkbackWindow);
	end;
	if self.sampleCloseDkbackWindow ~= nil then
		SoundUtil.deleteSample(self.sampleCloseDkbackWindow);
	end;
	if self.sampleCloseLeftWindow ~= nil then
		SoundUtil.deleteSample(self.sampleCloseLeftWindow);
	end;
	if self.sampleCloseRightWindow ~= nil then
		SoundUtil.deleteSample(self.sampleCloseRightWindow);
	end;
end;
function Series:mouseEvent(posX, posY, isDown, isUp, button)
end;
function Series:keyEvent(unicode, sym, modifier, isDown)
end;
function Series:update(dt)
    if self:getIsActive() and self.isClient then
		if self.isEntered then
			if self:getIsAnimationPlaying("MkleftDoor") and self:getIsActiveForSound() then
				if self.animations["Mkleftdoor"].currentSpeed > 0 and self.animations["MkleftDoor"].currentTime < 50 then
					if not SoundUtil.isSamplePlaying(self.sampleOpenMkDoorL, 1.5*dt) then
						SoundUtil.playSample(self.sampleOpenMkDoorL,1,1,nil);
					end;
				elseif self.animations["MkleftDoor"].currentSpeed < 0 and self.animations["MkleftDoor"].currentTime < 100 then
					if not SoundUtil.isSamplePlaying(self.sampleCloseMkDoorL, 1.5*dt) then
						SoundUtil.playSample(self.sampleCloseMkDoorL,1,1,nil);
					end;
				end;
			end;
			if self:getIsAnimationPlaying("MkrightDoor") and self:getIsActiveForSound() then
				if self.animations["MkrightDoor"].currentSpeed > 0 and self.animations["MkrightDoor"].currentTime < 50 then
					if not SoundUtil.isSamplePlaying(self.sampleOpenMkDoorR, 1.5*dt) then
						SoundUtil.playSample(self.sampleOpenMkDoorR,1,1,nil);
					end;
				elseif self.animations["MkrightDoor"].currentSpeed < 0 and self.animations["MkrightDoor"].currentTime < 100 then
					if not SoundUtil.isSamplePlaying(self.sampleCloseMkDoorR, 1.5*dt) then
						SoundUtil.playSample(self.sampleCloseMkDoorR,1,1,nil);
					end;
				end;
			end;
			if self.isEntered then
			if self:getIsAnimationPlaying("DkleftDoor") and self:getIsActiveForSound() then
				if self.animations["DkleftDoor"].currentSpeed > 0 and self.animations["DkleftDoor"].currentTime < 50 then
					if not SoundUtil.isSamplePlaying(self.sampleOpenDkDoorL, 1.5*dt) then
						SoundUtil.playSample(self.sampleOpenDkDoorL,1,1,nil);
					end;
				elseif self.animations["DkleftDoor"].currentSpeed < 0 and self.animations["DkleftDoor"].currentTime < 100 then
					if not SoundUtil.isSamplePlaying(self.sampleCloseDkDoorL, 1.5*dt) then
						SoundUtil.playSample(self.sampleCloseDkDoorL,1,1,nil);
					end;
				end;
			end;
			if self:getIsAnimationPlaying("DkrightDoor") and self:getIsActiveForSound() then
				if self.animations["DkrightDoor"].currentSpeed > 0 and self.animations["DkrightDoor"].currentTime < 50 then
					if not SoundUtil.isSamplePlaying(self.sampleOpenMkDoorR, 1.5*dt) then
						SoundUtil.playSample(self.sampleOpenMkDoorR,1,1,nil);
					end;
				elseif self.animations["DkrightDoor"].currentSpeed < 0 and self.animations["DkrightDoor"].currentTime < 100 then
					if not SoundUtil.isSamplePlaying(self.sampleCloseDkDoorR, 1.5*dt) then
						SoundUtil.playSample(self.sampleCloseDkDoorR,1,1,nil);
					end;
				end;
			end;
			if self:getIsAnimationPlaying("MkbackWindow") and self:getIsActiveForSound() then
				if self.animations["MkbackWindow"].currentSpeed > 0 and self.animations["MkbackWindow"].currentTime < 50 then
					if not SoundUtil.isSamplePlaying(self.sampleOpenMkbackWindow, 1.5*dt) then
						SoundUtil.playSample(self.sampleOpenMkbackWindow,1,1,nil);
					end;
				elseif self.animations["MkbackWindow"].currentSpeed < 0 and self.animations["MkbackWindow"].currentTime < 100 then
					if not SoundUtil.isSamplePlaying(self.sampleCloseMkbackWindow, 1.5*dt) then
						SoundUtil.playSample(self.sampleCloseMkbackWindow,1,1,nil);
					end;
				end;
			end;
			if self:getIsAnimationPlaying("DkbackWindow") and self:getIsActiveForSound() then
				if self.animations["DkbackWindow"].currentSpeed > 0 and self.animations["DkbackWindow"].currentTime < 50 then
					if not SoundUtil.isSamplePlaying(self.sampleOpenDkbackWindow, 1.5*dt) then
						SoundUtil.playSample(self.sampleOpenDkbackWindow,1,1,nil);
					end;
				elseif self.animations["DkbackWindow"].currentSpeed < 0 and self.animations["DkbackWindow"].currentTime < 100 then
					if not SoundUtil.isSamplePlaying(self.sampleCloseDkbackWindow, 1.5*dt) then
						SoundUtil.playSample(self.sampleCloseDkbackWindow,1,1,nil);
					end;
				end;
			end;
			if self:getIsAnimationPlaying("leftWindow") and self:getIsActiveForSound() then
				if self.animations["leftWindow"].currentSpeed > 0 and self.animations["leftWindow"].currentTime < 50 then
					if not SoundUtil.isSamplePlaying(self.sampleOpenLeftWindow, 1.5*dt) then
						SoundUtil.playSample(self.sampleOpenLeftWindow,1,1,nil);
					end;
				elseif self.animations["leftWindow"].currentSpeed < 0 and self.animations["leftWindow"].currentTime > 50 then
					if not SoundUtil.isSamplePlaying(self.sampleCloseLeftWindow, 1.5*dt) then
						SoundUtil.playSample(self.sampleCloseLeftWindow,1,1,nil);
					end;
				end;
			end;
			if self:getIsAnimationPlaying("rightWindow") and self:getIsActiveForSound() then
				if self.animations["rightWindow"].currentSpeed > 0 and self.animations["rightWindow"].currentTime < 50 then
					if not SoundUtil.isSamplePlaying(self.sampleOpenRightWindow, 1.5*dt) then
						SoundUtil.playSample(self.sampleOpenRightWindow,1,1,nil);
					end;
				elseif self.animations["rightWindow"].currentSpeed < 0 and self.animations["rightWindow"].currentTime < 100 then
					if not SoundUtil.isSamplePlaying(self.sampleCloseRightWindow, 1.5*dt) then
						SoundUtil.playSample(self.sampleCloseRightWindow,1,1,nil);
					end;
				end;
			end;
			local sound=false;
			for i=0, #self.soundAdj do
				if self.animations[self.soundAdj[i].animName] ~= nil and self.animations[self.soundAdj[i].animName].currentTime > 500 then
					self.sampleMotor.indoorVolumeFactor = math.max(self.soundAdj[i].volumeFactor, self.sampleMotor.indoorVolumeFactor);
					self.sampleMotor.indoorLowpassGain = math.max(self.soundAdj[i].lowpassGain, self.sampleMotor.indoorLowpassGain);
					self.sampleMotorStart.indoorVolumeFactor = math.max(self.soundAdj[i].volumeFactor, self.sampleMotorStart.indoorVolumeFactor);
					self.sampleMotorStart.indoorLowpassGain = math.max(self.soundAdj[i].lowpassGain, self.sampleMotorStart.indoorLowpassGain);
					self.sampleMotorStop.indoorVolumeFactor = math.max(self.soundAdj[i].volumeFactor, self.sampleMotorStop.indoorVolumeFactor);
					self.sampleMotorStop.indoorLowpassGain = math.max(self.soundAdj[i].lowpassGain, self.sampleMotorStop.indoorLowpassGain);
					
					self.sampleMotorRun.indoorVolumeFactor = math.max(self.soundAdj[i].volumeFactor, self.sampleMotorRun.indoorVolumeFactor);
					self.sampleMotorRun.indoorLowpassGain = math.max(self.soundAdj[i].lowpassGain, self.sampleMotorRun.indoorLowpassGain);
					self.sampleMotorLoad.indoorVolumeFactor = math.max(self.soundAdj[i].volumeFactor, self.sampleMotorLoad.indoorVolumeFactor);
					self.sampleMotorLoad.indoorLowpassGain = math.max(self.soundAdj[i].lowpassGain, self.sampleMotorLoad.indoorLowpassGain);
					sound=true;
				else
					if not sound then
						self.sampleMotor.indoorVolumeFactor = 0.55;
						self.sampleMotor.indoorLowpassGain = 0.2;
						self.sampleMotorStart.indoorVolumeFactor = 0.55;
						self.sampleMotorStart.indoorLowpassGain = 0.2;
						self.sampleMotorStop.indoorVolumeFactor = 0.55;
						self.sampleMotorStop.indoorLowpassGain = 0.2;
						
						self.sampleMotorRun.indoorVolumeFactor = 0.6;
						self.sampleMotorRun.indoorLowpassGain = 0.2;
						self.sampleMotorLoad.indoorVolumeFactor = 0.6;
						self.sampleMotorLoad.indoorLowpassGain = 0.2;
					end;
				end;
			end;
			SoundUtil.onCameraSwitched(self.activeCamera.isInside);
		end;
    end;
end;
function Series:updateTick(dt)
end;
function Series:draw()    
end;